"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
import pydantic
from speakeasy_client_sdk_python.models.shared import (
    codesamplesjobstatus as shared_codesamplesjobstatus,
)
from speakeasy_client_sdk_python.types import BaseModel
from speakeasy_client_sdk_python.utils import FieldMetadata, PathParamMetadata
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class GetCodeSamplePreviewAsyncRequestTypedDict(TypedDict):
    job_id: str
    r"""The ID of the job to check the status and retrieve results"""


class GetCodeSamplePreviewAsyncRequest(BaseModel):
    job_id: Annotated[
        str,
        pydantic.Field(alias="jobID"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""The ID of the job to check the status and retrieve results"""


class GetCodeSamplePreviewAsyncResponseBodyTypedDict(TypedDict):
    r"""Job is still in progress"""

    status: shared_codesamplesjobstatus.CodeSamplesJobStatus
    r"""The current status of the job. Possible values are `pending` or `running`."""


class GetCodeSamplePreviewAsyncResponseBody(BaseModel):
    r"""Job is still in progress"""

    status: shared_codesamplesjobstatus.CodeSamplesJobStatus
    r"""The current status of the job. Possible values are `pending` or `running`."""


class GetCodeSamplePreviewAsyncResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    two_hundred_application_json_response_stream: NotRequired[httpx.Response]
    r"""Successfully returned codeSample overlay file"""
    two_hundred_application_x_yaml_response_stream: NotRequired[httpx.Response]
    r"""Successfully returned codeSample overlay file"""
    two_hundred_and_two_application_json_object: NotRequired[
        GetCodeSamplePreviewAsyncResponseBodyTypedDict
    ]
    r"""Job is still in progress"""


class GetCodeSamplePreviewAsyncResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    two_hundred_application_json_response_stream: Optional[httpx.Response] = None
    r"""Successfully returned codeSample overlay file"""

    two_hundred_application_x_yaml_response_stream: Optional[httpx.Response] = None
    r"""Successfully returned codeSample overlay file"""

    two_hundred_and_two_application_json_object: Optional[
        GetCodeSamplePreviewAsyncResponseBody
    ] = None
    r"""Job is still in progress"""
