"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
import pydantic
from speakeasy_client_sdk_python.models.shared import (
    suggestrequestbody as shared_suggestrequestbody,
)
from speakeasy_client_sdk_python.types import BaseModel
from speakeasy_client_sdk_python.utils import (
    FieldMetadata,
    HeaderMetadata,
    RequestMetadata,
)
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class SuggestRequestTypedDict(TypedDict):
    x_session_id: str
    suggest_request_body: shared_suggestrequestbody.SuggestRequestBodyTypedDict
    r"""The OAS summary and diagnostics to use for the suggestion."""


class SuggestRequest(BaseModel):
    x_session_id: Annotated[
        str,
        pydantic.Field(alias="x-session-id"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ]

    suggest_request_body: Annotated[
        shared_suggestrequestbody.SuggestRequestBody,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]
    r"""The OAS summary and diagnostics to use for the suggestion."""


class SuggestResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    schema_: NotRequired[httpx.Response]
    r"""An overlay containing the suggested spec modifications."""


class SuggestResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    schema_: Optional[httpx.Response] = None
    r"""An overlay containing the suggested spec modifications."""
