"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
import pydantic
from speakeasy_client_sdk_python.models.shared import (
    suggestrequestbody as shared_suggestrequestbody,
)
from speakeasy_client_sdk_python.types import BaseModel
from speakeasy_client_sdk_python.utils import (
    FieldMetadata,
    HeaderMetadata,
    PathParamMetadata,
    RequestMetadata,
)
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class SuggestOpenAPIRegistryRequestTypedDict(TypedDict):
    x_session_id: str
    namespace_name: str
    revision_reference: str
    r"""Tag or digest"""
    suggest_request_body: NotRequired[
        shared_suggestrequestbody.SuggestRequestBodyTypedDict
    ]
    r"""Suggest options"""


class SuggestOpenAPIRegistryRequest(BaseModel):
    x_session_id: Annotated[
        str,
        pydantic.Field(alias="x-session-id"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ]

    namespace_name: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]

    revision_reference: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""Tag or digest"""

    suggest_request_body: Annotated[
        Optional[shared_suggestrequestbody.SuggestRequestBody],
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ] = None
    r"""Suggest options"""


class SuggestOpenAPIRegistryResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    schema_: NotRequired[httpx.Response]
    r"""An overlay containing the suggested spec modifications."""


class SuggestOpenAPIRegistryResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    schema_: Optional[httpx.Response] = None
    r"""An overlay containing the suggested spec modifications."""
