"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .remotesourcesubscriptionsettings import (
    RemoteSourceSubscriptionSettings,
    RemoteSourceSubscriptionSettingsTypedDict,
)
from datetime import datetime
from speakeasy_client_sdk_python.types import BaseModel
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class CompositeSpecMetadataTypedDict(TypedDict):
    subscription_id: str
    r"""The subscription ID for the remote source subscription, if applicable. This indicates that the namespace is created by a remote source and thus is composite."""
    subscription_settings: RemoteSourceSubscriptionSettingsTypedDict


class CompositeSpecMetadata(BaseModel):
    subscription_id: str
    r"""The subscription ID for the remote source subscription, if applicable. This indicates that the namespace is created by a remote source and thus is composite."""

    subscription_settings: RemoteSourceSubscriptionSettings


class NamespaceTypedDict(TypedDict):
    r"""A namespace contains many revisions."""

    created_at: datetime
    id: str
    r"""{organization_slug}/{workspace_slug}/{namespace_name}"""
    name: str
    r"""A human-readable name for the namespace."""
    updated_at: datetime
    composite_spec_metadata: NotRequired[CompositeSpecMetadataTypedDict]
    public: NotRequired[bool]
    r"""Indicates whether the namespace is publicly accessible"""


class Namespace(BaseModel):
    r"""A namespace contains many revisions."""

    created_at: datetime

    id: str
    r"""{organization_slug}/{workspace_slug}/{namespace_name}"""

    name: str
    r"""A human-readable name for the namespace."""

    updated_at: datetime

    composite_spec_metadata: Optional[CompositeSpecMetadata] = None

    public: Optional[bool] = None
    r"""Indicates whether the namespace is publicly accessible"""
